<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <div>
    <suspense-mutation
      :mutation="submitMutation"
      :success-timeout="5000"
      transition="slide-y-transition"
      transition-mode="out-in"
    >
      <!-- Error -->
      <template #error>
        <v-row no-gutters>
          <v-col>
            <v-alert class="studium-alert" dense text type="error">
              {{ submitMutationError.message }}
            </v-alert>
          </v-col>
        </v-row>
      </template>

      <!-- Success -->
      <template #success>
        <v-row no-gutters>
          <v-col>
            <v-alert class="studium-alert" dense text type="success"> {{ $t('report.sent') }} </v-alert>
          </v-col>
        </v-row>
      </template>
    </suspense-mutation>

    <!-- Form -->
    <v-form ref="form" :disabled="submitMutation.loading.value" lazy-validation>
      <v-row>
        <!-- Message -->
        <v-col v-if="!config.message.hidden" cols="12" class="pb-0">
          <v-textarea
            v-model="fields.message"
            :rules="rules.message"
            :counter="1000"
            :readonly="config.message.readonly"
            :disabled="config.message.readonly"
            class="studium-input"
            :label="$t('report.message')"
            color="primary"
            outlined
          />
        </v-col>
      </v-row>

      <!-- Submit -->
      <v-row justify="end">
        <v-btn
          class="studium-button"
          color="primary"
          text
          large
          :ripple="false"
          :loading="submitMutation.loading.value"
          @click="submit"
        >
          {{ $t('report.send') }}
        </v-btn>
      </v-row>
    </v-form>
  </div>
</template>

<script>
import { defineComponent, reactive, ref } from '@vue/composition-api'

import { useReportDocumentMutation } from '~/apollo/_generated'
import { useErrorHandler } from '~/util/composables/'

export default defineComponent({
  props: {
    // Configuration for the code field
    code: {
      type: String,
      default: () => {},
    },

    // Configuration for the filename field
    filename: {
      type: String,
      default: () => {},
    },

    // Configuration for the message field
    message: {
      type: Object,
      default: () => {},
    },
  },
  setup(props) {
    // Form element binding
    const form = ref()

    // Form configuration defaults
    const configDefault = {
      defaultValue: '',
      hidden: false,
      readonly: false,
      autofill: false,
    }

    // Form configuration
    const config = reactive({
      message: { ...configDefault, ...props.message },
    })

    // Form fields
    const fields = reactive({
      message: config.message.defaultValue,
    })

    // Form rules
    const rules = {
      message: [
        // Required
        (v) => !!v || 'Message is required',
        // Length
        (v) => (v && v.length >= 10) || 'Message must be at least 10 characters',
        (v) => (v && v.length <= 1000) || 'Message cannot be larger than 1000 characters',
      ],
    }

    // Submit successfull
    const submitSuccess = ref(false)

    // Submit mutation
    const submitMutation = useReportDocumentMutation({})
    const submitMutationError = useErrorHandler(submitMutation)

    // Clear form and show success when submit mutation succeeds
    submitMutation.onDone(() => {
      // Reset the form validation
      form.value.resetValidation()
      // Reset the form content
      fields.message = config.message.defaultValue

      // Show success message.
      submitSuccess.value = true
    })

    // Submit action
    function submit() {
      // Make sure the form is valid - wouldnt let me pass props.code in object
      if (form.value.validate()) {
        const code = props.code
        const filename = props.filename
        submitMutation.mutate({ ...fields, code, filename })
      }
    }

    return {
      form,
      config,
      fields,
      rules,
      submitSuccess,
      submitMutation,
      submitMutationError,
      submit,
    }
  },
})
</script>
